commit dd31cb03116dbce167f8826c09c1a84c1b7a1623
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Mar 2 17:27:59 2020 +0100

    Documentation restructured and overhauled.

diff --git a/doc/activitydiagrams/core/urtCoreInit.uml b/doc/activitydiagrams/core/urtCoreInit.uml
index c7a5a6c..6b20433 100644
--- a/doc/activitydiagrams/core/urtCoreInit.uml
+++ b/doc/activitydiagrams/core/urtCoreInit.uml
@@ -30,8 +30,7 @@ title **µRtWare**\nurtCoreInit()\n
 note
   -- //void// --
   ====
-  -- **return** : urt_status_t --
-  Always returns ""URT_STATUS_OK"".
+  -- **return** : void --
 endnote
 
 /'### PROCEDURE ##############################################################'/
@@ -39,19 +38,16 @@ endnote
 start
 :initialize members;
 note
-  **_nodes** ← ""NULL""
-  urtEventSourceInit(**_evtSource**)
-  urtMutexInit(**_lock**)
-  **_status** ← ""URT_STATUS_OK""
+  * **_nodes** ← ""NULL""
+  * urtEventSourceInit(**_evtSource**)
+  * urtMutexInit(**_lock**)
+  * **_status** ← ""URT_STATUS_OK""
   .. URT_CFG_PUBSUB_ENABLED == true ..
-  **_topics** ← ""NULL""
+  * **_topics** ← ""NULL""
   .. URT_CFG_RPC_ENABLED == true ..
-  **_services** ← ""NULL""
+  * **_services** ← ""NULL""
 endnote
 stop
-note
-  Returns ""URT_STATUS_OK"".
-endnote
 
 /'### OUTRO ##################################################################'/
 
diff --git a/doc/activitydiagrams/core/urtCoreStartNodes.uml b/doc/activitydiagrams/core/urtCoreStartNodes.uml
index 4f00fbf..3d67e68 100644
--- a/doc/activitydiagrams/core/urtCoreStartNodes.uml
+++ b/doc/activitydiagrams/core/urtCoreStartNodes.uml
@@ -30,8 +30,7 @@ title **µRtWare**\nurtCoreStartNodes()\n
 note
   -- //void// --
   ====
-  -- **return** : urt_status_t --
-  Always returns ""URT_STATUS_OK"".
+  -- **return** : void --
 endnote
 
 /'### PROCEDURE ##############################################################'/
@@ -45,9 +44,6 @@ while (Current node is not ""NULL""?) is (yes)
 endwhile (no)
 :unlock core;
 stop
-note
-  Returns ""URT_STATUS_OK"".
-endnote
 
 /'### OUTRO ##################################################################'/
 
diff --git a/doc/activitydiagrams/core/urtCoreStopNodes.uml b/doc/activitydiagrams/core/urtCoreStopNodes.uml
index 9bd82a3..5d15f63 100644
--- a/doc/activitydiagrams/core/urtCoreStopNodes.uml
+++ b/doc/activitydiagrams/core/urtCoreStopNodes.uml
@@ -33,28 +33,42 @@ note
   For normal shutdown ""URT_STATUS_OK"" should be used.
   ====
   -- **return** : urt_status_t --
-  Always returns ""URT_STATUS_OK"".
+  Returns ""URT_STATUS_OK"" if there was no call with another reason than ""URT_STATUS_OK"" before.
+  If the function has been called before with a different reason, that reason is returned.
 endnote
 
 /'### PROCEDURE ##############################################################'/
 
 start
 :lock core;
-if (Current ""_status"" value is smaller than specified reason?) then (yes)
-  :set core's ""_status"" value to argument;
+if (Current core ""_status"" value is ""URT_STATUS_OK""?) then (yes)
+  if (Thread priority is lower than ""URT_THREAD_PRIO_HIGH_MAX""?) then (yes)
+    :boost thread priority to ""URT_THREAD_PRIO_HIGH_MAX"";
+  else (no)
+  endif
+  :set core's ""_status"" variable to argument;
+  :access first node in core's list of nodes;
+  while (Current node is not ""NULL""?) is (yes)
+    :request node to terminate;
+    :proceed to next node;
+  endwhile (no)
+  :broadcast control event (terminate);
+  :unlock core;
+  if (Thread boosted its priority?) then (yes)
+    :reset thread priority;
+  else (no)
+  endif
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
 else (no)
+  :unlock core;
+  stop
+  note
+    Returns the previously set ""_status"" value.
+  endnote
 endif
-:access first node in core's list of nodes;
-while (Current node is not ""NULL""?) is (yes)
-  :request node to terminate;
-  :proceed to next node;
-endwhile (no)
-:broadcast control event (terminate);
-:unlock core;
-stop
-note
-  Returns ""URT_STATUS_OK"".
-endnote
 
 /'### OUTRO ##################################################################'/
 
diff --git a/doc/activitydiagrams/core/urtCoreSynchronizeNodes.uml b/doc/activitydiagrams/core/urtCoreSynchronizeNodes.uml
index bb4c397..1097d78 100644
--- a/doc/activitydiagrams/core/urtCoreSynchronizeNodes.uml
+++ b/doc/activitydiagrams/core/urtCoreSynchronizeNodes.uml
@@ -34,8 +34,8 @@ note
   ====
   -- **return** : urt_status_t --
   Returns ""URT_STATUS_OK"" if all nodes are synchronized and proceed.
-  Returns ""URT_STATUS_ERROR"" if an exception occurred (faulty stage value detected).
-  Returns a value greater than ""URT_STATUS_OK"" but smaller than ""URT_STATUS_ERROR"" if there are nodes left to synchronize.
+  Returns ""URT_STATUS_SYNC_ERROR"" if an exception occurred (faulty stage value detected).
+  Returns ""URT_STATUS_SYNC_PENDING"" if there are nodes left to synchronize.
   In the latter case, the node thread must still wait for the control event (proceed) to synchronize.
 endnote
 
@@ -48,27 +48,25 @@ start
 while (Current node is not ""NULL""\nand stage of current node is equal to argument?) is (yes)
   :proceed to next node;
 endwhile (no)
-if (The stage of a node was equal to the argument or 1 less than the argument?) then (yes)
-  :call ""urtCoreStopNodes(URT_STATUS_ERROR)"";
+if (All nodes are at the same stage?) then (yes)
+  :broadcast control event (proceed);
   :unlock core;
   stop
   note
-    Returns ""URT_STATUS_ERROR"".
+    Returns ""URT_STATUS_OK"".
   endnote
-else (no)
-endif
-if (Stages of all nodes are equal to argument?) then (yes)
-  :broadcast control event (proceed);
+elseif (The stage of the last checked node was one less than the argument?) then (yes)
   :unlock core;
   stop
   note
-    Returns ""URT_STATUS_OK"".
+    Returns a ""URT_STATUS_SYNC_PENDING"".
   endnote
 else (no)
+  :call ""urtCoreStopNodes(URT_STATUS_SYNC_ERROR)"";
   :unlock core;
   stop
   note
-    Returns a value greater than ""URT_STATUS_OK"" but smaller than ""URT_STATUS_ERROR"".
+    Returns ""URT_STATUS_SYNC_ERROR"".
   endnote
 endif
 
diff --git a/doc/activitydiagrams/functions.iuml b/doc/activitydiagrams/functions.iuml
index 99c7563..75ed3fb 100644
--- a/doc/activitydiagrams/functions.iuml
+++ b/doc/activitydiagrams/functions.iuml
@@ -23,9 +23,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 !function $contribute_messages()
   partition "contribute messages" {
     fork
-      :set next pointer of topic's latest message to first message to contribute;
+      :set ""next"" pointer of last message to contribute to the message after the topic's latest message;
     fork again
-      :set next pointer of last message to contribute to the message after the topic's latest message;
+      :set ""next"" pointer of topic's latest message to first message to contribute;
     endfork
   }
 !endfunction
diff --git a/doc/activitydiagrams/message/urtMessageInit.uml b/doc/activitydiagrams/message/urtMessageInit.uml
index 4a10279..0865f2b 100644
--- a/doc/activitydiagrams/message/urtMessageInit.uml
+++ b/doc/activitydiagrams/message/urtMessageInit.uml
@@ -34,8 +34,7 @@ note
   -- **payload** : void* --
   May be ""NULL"" for messages without payload.
   ====
-  -- **return** : urt_status_t --
-  Always returns ""URT_STATUS_OK"".
+  -- **return** : void --
 endnote
 
 /'### PROCEDURE ##############################################################'/
@@ -43,17 +42,14 @@ endnote
 start
 :initialize members;
 note
-  **next** ← ""NULL""
-  **payload** ← payload
-  **originTime** ← 0
-  **numHrtConsumbersLeft** ← 0
+  * **next** ← ""NULL""
+  * **payload** ← payload
+  * **originTime** ← 0
+  * **numHrtConsumbersLeft** ← 0
   .. URT_CFG_PUBSUB_PROFILING == true ..
-  **numConsumersLeft** ← 0
+  * **numConsumersLeft** ← 0
 endnote
 stop
-note
-  Returns ""URT_STATUS_OK"".
-endnote
 
 /'### OUTRO ##################################################################'/
 
diff --git a/doc/activitydiagrams/node/_main.uml b/doc/activitydiagrams/node/_main.uml
index 8e8d5b1..a5a9640 100644
--- a/doc/activitydiagrams/node/_main.uml
+++ b/doc/activitydiagrams/node/_main.uml
@@ -30,7 +30,7 @@ title **µRtWare**\n_main()\n
 note
   -- **arg** : void* --
   Optional Argument to the thread main function (see ""urt_osThreadFunction_t"").
-  This functions expects no arguments.
+  This function expects ""arg"" to be of type ""urt_node_t*"".
   ====
   -- **return** : void --
 endnote
@@ -46,11 +46,11 @@ partition "setup" {
       Callback must not loop.
     endnote
     if (Event mask returned by ""setupcallback()"" redefines core event?) then (yes)
-      :call ""urtCoreStopNodes(URT_STATUS_ERROR)"";
+      :call ""urtCoreStopNodes(URT_STATUS_NODE_INVALEVTMASK)"";
     else (no)
     endif
   else (no)
-    :act as if ""stupcallback"" returned 0xF..F;
+    :act as if ""setupcallback"" returned 0xF..F;
   endif
   if (Core status is ""URT_STATUS_OK""?) then (yes)
     :suspend all child threads (recursively);
@@ -60,7 +60,7 @@ partition "setup" {
   endif
 }
 partition "loop" {
-  while (Thread termination requested?) is (no)
+  while (Termination of node thread requested?) is (no)
     :Wait for a specified or a core event;
     if (Core event received?) then (yes)
     else (no)
@@ -68,16 +68,20 @@ partition "loop" {
       note
         Callback must not loop.
       endnote
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true || URT_CFG_RPC_PROFILING = true//..\nincrement loop counter;
       if (Event mask returned by ""loopcallback()"" redefines core event?) then (yes)
-        :call ""urtCoreStopNodes(URT_STATUS_ERROR)"";
+        :call ""urtCoreStopNodes(URT_STATUS_NODE_INVALEVTMASK)"";
       else (no)
       endif
     endif
-  endwhile
+  endwhile (yes)
 }
 partition "outro" {
   if (Node's ""shutdowncallback"" is set?) then (yes)
     :execute ""shutdowncallback()"" with core's status as argument;
+    note
+      Callback must terminate.
+    endnote
   else (no)
   endif
   :unregister from core event;
diff --git a/doc/activitydiagrams/node/urtNodeInit.uml b/doc/activitydiagrams/node/urtNodeInit.uml
index deeb45e..a7070b9 100644
--- a/doc/activitydiagrams/node/urtNodeInit.uml
+++ b/doc/activitydiagrams/node/urtNodeInit.uml
@@ -36,20 +36,26 @@ note
   Must not be ""NULL"".
   -- **setupcallback** : urt_nodeSetupCallback_t* --
   Callback function to be executed during setup.
-  May be ""NULL"" if no setup is required.
+  May be ""NULL"" if no custom setup is required.
   --  **setupparams** : void*--
-  Optional parameters for the setup callback function.
-  Must be ""NULL"" if no callback is specified.
-  May be ""NULL"" if the specified callback does not expect parameters.
+  Parameters for the setup callback function.
+  Must be ""NULL"" if no setup callback is specified.
+  May be ""NULL"" if the specified setup callback does not expect parameters.
   -- **loopcallback** : urt_nodeLoopCallback_t* --
   Callback function to be executed in a loop.
   Must not be ""NULL"".
   -- **loopparams** : void* --
-  Optional parameters for the loop callback function.
-  May be ""NULL"" if the specified callback does not expect parameters.
+  Parameters for the loop callback function.
+  May be ""NULL"" if the specified loop callback does not expect parameters.
+  -- **shutdowncallback** : urt_nodeShutdownCallback_t* --
+  Callback function to be executed during shutdown.
+  May be ""NULL"" if no custom shutdown is required.
+  -- **shutdownparams** : void* --
+  Parameters for the loop callback function.
+  Must be ""NULL"" if no shutdown callback is specified.
+  May be ""NULL"" if the specified shutdown callback does not expect parameters.
   ====
-  -- **return** : urt_status_t --
-  Always returns ""URT_STATUS_OK"".
+  -- **return** : void --
 endnote
 
 /'### PROCEDURE ##############################################################'/
@@ -57,27 +63,29 @@ endnote
 start
 :initialize members;
 note
-  **next** ← ""NULL""
-  **thread** ← thread
-  **setupcallback** ← setupcallback
-  **setupparams** ← setupparams
-  **loopcallback** ← loopcallback
-  **loopparams** ← loopparams
-  **stage** ← 0
-  urtEventListenerInit(**listener**)
+  * **next** ← ""NULL""
+  * **thread** ← thread
+  * **setupcallback** ← setupcallback
+  * **setupparams** ← setupparams
+  * **loopcallback** ← loopcallback
+  * **loopparams** ← loopparams
+  * **shutdowncallback** ← loopcallback
+  * **shutdownparams** ← loopparams
+  * **stage** ← 0
+  * urtEventListenerInit(**listener**)
   .. URT_CFG_PUBSUB_PROFILING == true || URT_CFG_RPC_PROFILING = true ..
-  **loops** ← 0
+  * **loops** ← 0
 endnote
 :lock core;
-:prepend self to core's list of nodes;
-note
-  List is not ordered.
-endnote
+partition "prepend self to core's list of nodes" {
+  fork
+    :set this node's ""next"" pointer to the first node in the core's list of nodes;
+  fork again
+    :set core's node pointer to this node;
+  endfork
+}
 :unlock core;
 stop
-note
-  Returns ""URT_STATUS_OK"".
-endnote
 
 /'### OUTRO ##################################################################'/
 
diff --git a/doc/activitydiagrams/publisher/urtPublisherInit.uml b/doc/activitydiagrams/publisher/urtPublisherInit.uml
index 6c4c2ec..3ad5160 100644
--- a/doc/activitydiagrams/publisher/urtPublisherInit.uml
+++ b/doc/activitydiagrams/publisher/urtPublisherInit.uml
@@ -42,8 +42,7 @@ note
   Once a message has been contributed, it cannot be removed later.
   May be ""NULL"" (no messages to contribute).
   ====
-  -- **return** : urt_status_t --
-  Always returns ""URT_STATUS_OK"".
+  -- **return** : void --
 endnote
 
 /'### PROCEDURE ##############################################################'/
@@ -51,10 +50,10 @@ endnote
 start
 :initialize members;
 note
-  **topic** ← topic
+  * **topic** ← topic
   .. URT_CFG_PUBSUB_PROFILING == true ..
-  **publishAttempts** ← 0
-  **publishFails** ← 0
+  * **publishAttempts** ← 0
+  * **publishFails** ← 0
 endnote
 if (Messages to contribute?) then (yes)
   :lock topic;
@@ -63,9 +62,6 @@ if (Messages to contribute?) then (yes)
 else (no)
 endif
 stop
-note
-  Returns ""URT_STATUS_OK"".
-endnote
 
 /'### OUTRO ##################################################################'/
 
diff --git a/doc/activitydiagrams/publisher/urtPublisherPublish.uml b/doc/activitydiagrams/publisher/urtPublisherPublish.uml
index 3b5aaab..87d1a0d 100644
--- a/doc/activitydiagrams/publisher/urtPublisherPublish.uml
+++ b/doc/activitydiagrams/publisher/urtPublisherPublish.uml
@@ -34,7 +34,7 @@ note
   -- **payload** : void* --
   Pointer to the data to be published.
   May be ""NULL"" for messages without payload.
-  -- **n** : size_t --
+  -- **bytes** : size_t --
   Size of the payload in bytes.
   -- **t** : urt_osTime_t --
   Timestamp to be set for the message.
@@ -43,50 +43,77 @@ note
   ====
   -- **return** : urt_status_t --
   Returns ""URT_STATUS_OK"" on success.
-  Returns ""URT_STATUS_ERROR"" on timeout.
+  Returns ""URT_STATUS_PUBLISH_TIMEOUT"" on timeout.
 endnote
 
 /'### PROCEDURE ##############################################################'/
 
 start
 :lock topic;
-:access topic's next message;
+fork
+  :access topic's next message;
+fork again
+  #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of publish attempts;
+endfork
 while (HRT consumers left for the message?) is (yes)
   :wait for topic's condition variable (using topic's mutex) to be signaled or timeout;
   if (Timeout occurred?) then (yes)
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of publish fails;
     :unlock topic;
     stop
     note
-      Returns ""URT_STATUS_ERROR"".
+      Returns ""URT_STATUS_PUBLISH_TIMEOUT"".
     endnote
   else (no)
     if (Message timestamp was modified?) then (yes)
-      :access topic's next message;
+      repeat
+        :proceed to next message;
+      repeat while (Timestamp is younger than of previous message?) is (yes)
+      ->no;
     else (no)
     endif
   endif
 endwhile (no)
+partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+  if (Consumers left for this message?) then (yes)
+    #EEEEEE:increment counter of discarded messages (@topic);
+  else (no)
+  endif
+}
 fork
-  fork
-    :iterate topic pointer to this message;
-  fork again
-    :copy payload to message;
-  fork again
-    :set origin time of message;
-  fork again
-    :set number of HRT consumers (from topic);
-  endfork
+  partition "setup message" {
+    fork
+      :iterate topic's pointer to this message;
+    fork again
+      :copy payload to message;
+    fork again
+      :set origin time of message;
+    fork again
+      :set number of HRT consumers (from topic);
+    fork again
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..
+       set numer of consumers (from topic);
+    endfork
+  }
 fork again
-  :set QoS rate timer (@topic) wrt. most critical HRT subscriber;
+  #EEEEEE:..//URT_CFG_PUBSUB_QOS_RATECHECKS == true//..\nset QoS rate timer (@topic) wrt. most critical HRT subscriber;
 fork again
-  while (HRT subscribers left?) is (yes)
-    if (QoS delay timer (@subscriber) is not armed?) then (yes)
-      :set QoS delay timer (@subscriber) wrt. origin time of the message;
-      note: No lock required since this timer is only accessed when the topic is locked.
-    else (no)
-    endif
-    :iterate to next HRT subscriber;
-  endwhile (no)
+  partition "//URT_CFG_PUBSUB_QOS_DEADLINECHECKS == true//" #EEEEEE {
+    #EEEEEE:access first HRT subscriber of topic;
+    while (HRT subscriber is not ""NULL""?) is (yes)
+      if (QoS deadline timer (@subscriber) is not armed?) then (yes)
+        #EEEEEE:set QoS deadline timer (@subscriber) wrt. origin time of the message;
+        note
+          No lock required.
+          This timer is only accessed while topic is locked.
+        endnote
+      else (no)
+      endif
+      #EEEEEE:proceed to next HRT subscriber;
+    endwhile (no)
+  }
+fork again
+  #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of published messages (@topic);
 endfork
 :fire event;
 note: Msut be within topic lock because of HRT counter.
diff --git a/doc/activitydiagrams/service/urtServiceCall.uml b/doc/activitydiagrams/service/urtServiceCall.uml
index 1cc7e8e..faa9e5c 100644
--- a/doc/activitydiagrams/service/urtServiceCall.uml
+++ b/doc/activitydiagrams/service/urtServiceCall.uml
@@ -35,7 +35,7 @@ note
   Optional argument for the service call.
   May be ""NULL"" if the service expects no arguments.
   -- **ret** : void* --
-  Pointer to an optional return value.
+  Pointer to an optional output value.
   May be ""NULL"".
   -- **timeout** : urt_delay_t --
   Timeout delay to be propagated to the callback function.
@@ -48,7 +48,25 @@ endnote
 /'### PROCEDURE ##############################################################'/
 
 start
+#EEEEEE:..//URT_CFG_RPC_PROFILING == true//..\nincrement call counter;
 :execute the service ""callback"" function;
+partition "//URT_CFG_RPC_PROFILING == true//" #EEEEEE {
+  fork
+    #EEEEEE:accumulate sum of durations;
+  fork again
+    if (Calback returned ""URT_STATUS_SERVICE_TIMEOUT""?) then (yes)
+      #EEEEEE:increment timeout counter;
+    else (no)
+    endif
+  fork again
+    if (Duration was shorter than ""minDuration""?) then (yes)
+      #EEEEEE:update ""minDuration"" value;
+    elseif (Duration was longer than ""maxDuration""?) then (yes)
+      #EEEEEE:update ""maxDuration"" value;
+    else (no)
+    endif
+  endfork
+}
 stop
 note
   Returns the return value of the callback.
diff --git a/doc/activitydiagrams/service/urtServiceInit.uml b/doc/activitydiagrams/service/urtServiceInit.uml
index b695023..838e291 100644
--- a/doc/activitydiagrams/service/urtServiceInit.uml
+++ b/doc/activitydiagrams/service/urtServiceInit.uml
@@ -39,7 +39,7 @@ note
   ====
   -- **return** : urt_status_t --
   Returns ""URT_STATUS_OK"" on success.
-  Returns ""URT_STATUS_ERROR"" if another service with the same identifier already exists.
+  Returns ""URT_STATUS_SERVICE_DUPLICATE"" if another service with the same identifier already exists.
 endnote
 
 /'### PROCEDURE ##############################################################'/
@@ -47,17 +47,16 @@ endnote
 start
 :initialize members;
 note
-  **next** ← ""NULL""
-  **id** ← id
-  urtMutexInit(**lock**)
-  **callback** ← callback
-  .. URT_CFG_RPC_QOS_JITTERCHECKS == true || URT_CFG_RPC_PROFILING == true ..
-  **minDuration** ← 0xF..F
-  **maxDuration** ← 0
+  * **next** ← ""NULL""
+  * **id** ← id
+  * urtMutexInit(**lock**)
+  * **callback** ← callback
   .. URT_CFG_RPC_PROFILING == true ..
-  **sumDurations** ← 0
-  **numCalls** ← 0
-  **numTimeouts** ← 0
+  * **minDuration** ← 0xF..F
+  * **maxDuration** ← 0
+  * **sumDurations** ← 0
+  * **numCalls** ← 0
+  * **numTimeouts** ← 0
 endnote
 :lock core;
 :access first service;
@@ -82,7 +81,7 @@ else (no)
   :unlock core;
   stop
   note
-    Returns ""URT_STATUS_ERROR"":
+    Returns ""URT_STATUS_SERVICE_DUPLICATE"":
   endnote
 endif
 
diff --git a/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberCalculateValidity.uml b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberCalculateValidity.uml
new file mode 100644
index 0000000..5620773
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberCalculateValidity.uml
@@ -0,0 +1,58 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtFrtSubscriberCalculateValidity()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_frtsubscriber_t* --
+  The FRT subscriber to calculate a validity for.
+  Must not be ""NULL"".
+  -- **latency** : urt_delay_t --
+  Latency (of a message) as argument to calculate validity.
+  ====
+  -- **return** : bool --
+  Returns a boolean indicator whether the latency is fine.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Latency is lower than the deadline offset and within allowed jitter?) then (yes)
+  stop
+  note
+    Returns ""true"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""false"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberFetchLatestMessage.uml b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberFetchLatestMessage.uml
new file mode 100644
index 0000000..b88b67c
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberFetchLatestMessage.uml
@@ -0,0 +1,106 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtFrtSubscriberFetchLatestMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_frtsubscriber_t* --
+  The FRT subscriber that shall fetch the latest message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+  Returns ""URT_STATUS_JITTERVIOLATION"" if the message's latency violated the maximum expected jitter.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  $find_latest_message()
+  if (Timestamp equals local copy?) then (yes)
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+    endnote
+  else (no)
+    fork
+      $fetch_message()
+    fork again
+      :calculate message latency;
+      note
+        Can be optimized in case all flags are disabled.
+      endnote
+      fork
+        #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+      fork again
+        partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+          if (Latency is lower than ""minLatency"" but within allowed jitter range?) then (yes)
+            #EEEEEE:update ""minLatency"" value;
+          elseif (Latency is greater than ""maxLatency"" but within allowed jitter range?) then (yes)
+            #EEEEEE:update ""maxLatency"" value;
+          else (no)
+          endif
+        }
+      fork again
+        if (Optional ""latency"" output argument given?) then (yes)
+          :set ""latency"" value;
+        else (no)
+        endif
+      fork again
+      endfork
+    endfork
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_OK"" or ""URT_STATUS_JITTERVIOLATION"".
+    endnote
+  endif
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberFetchNextMessage.uml b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberFetchNextMessage.uml
new file mode 100644
index 0000000..6a88ed0
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/frtsubscriber/urtFrtSubscriberFetchNextMessage.uml
@@ -0,0 +1,121 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtFrtSubscriberFetchNextMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_frtsubscriber_t* --
+  The FRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+  Returns ""URT_STATUS_JITTERVIOLATION"" if the message's latency violated the maximum expected jitter.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  if (Timestamp of last read message equals local copy?) then (yes)
+    if (Next message is younger?) then (yes)
+      :proceed to next message;
+    else (no)
+      :unlock topic;
+      stop
+      note
+        Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+      endnote
+    endif
+  else (no)
+    partition "find oldest message" {
+      repeat
+        :proceed to next message;
+      repeat while (Timestamp of next message is younger?) is (yes)
+    }
+  endif
+  fork
+    $fetch_message()
+  fork again
+    :calculate message latency;
+    note
+      Can be optimized in case all flags are disabled.
+    endnote
+    fork
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+    fork again
+      partition "//URT_CFG_PUBSUB_QOS_JITTERCHECKS == true || URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+        if (Latency is lower than ""minLatency"" but within allowed jitter range?) then (yes)
+          #EEEEEE:update ""minLatency"" value;
+        elseif (Latency is greater than ""maxLatency"" but within allowed jitter range?) then (yes)
+          #EEEEEE:update ""maxLatency"" value;
+        else (no)
+        endif
+      }
+    fork again
+      if (Optional ""latency"" output argument given?) then (yes)
+        :set ""latency"" value;
+      else (no)
+      endif
+    endfork
+  fork again
+    partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+      fork
+        #EEEEEE:decrement counter of consumers left (@message);
+      fork again
+        #EEEEEE:increment counter of received messages;
+      endfork
+    }
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"" or ""URT_STATUS_JITTERVIOLATION"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
